package view;

import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.net.URL;
import javax.swing.*;
import model.Direction;
import model.GameBoard;
import model.Player;

public class GameWindow extends JFrame implements KeyListener {
    private final GameBoard gameBoard = new GameBoard(2, 32);
    private final Timer timer = new Timer(40, e -> doMovements());

    /**
     * Creates new form GameWindow
     */
    public GameWindow() {
        initComponents();
        URL url = GameWindow.class.getClassLoader().getResource("res/pacman.png");
        setIconImage(Toolkit.getDefaultToolkit().getImage(url));
        setLocationRelativeTo(null);
        timer.setRepeats(true);
        timer.start();
        addKeyListener(this);
    }
    
    

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        gamePanel1 = new GamePanel(gameBoard);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("PacMan");
        setResizable(false);

        gamePanel1.setBackground(new java.awt.Color(255, 255, 255));

        javax.swing.GroupLayout gamePanel1Layout = new javax.swing.GroupLayout(gamePanel1);
        gamePanel1.setLayout(gamePanel1Layout);
        gamePanel1Layout.setHorizontalGroup(
            gamePanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 833, Short.MAX_VALUE)
        );
        gamePanel1Layout.setVerticalGroup(
            gamePanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 354, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(gamePanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(gamePanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 354, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GameWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GameWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GameWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GameWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GameWindow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private view.GamePanel gamePanel1;
    // End of variables declaration//GEN-END:variables

    private void doMovements() {
        gameBoard.movePlayers();
        gamePanel1.repaint();
        Player p = gameBoard.getPlayer(1);
        //setTitle("PacMan " + p.smoothX + " : " + p.smoothY);
    }

    @Override
    public void keyTyped(KeyEvent ke) {
    }

    @Override
    public void keyPressed(KeyEvent ke) {
        String str = "";
        if (ke.getKeyCode() == KeyEvent.VK_A){
            gameBoard.changePlayerDirection(0, Direction.LEFT);
        } else if (ke.getKeyCode() == KeyEvent.VK_D){
            gameBoard.changePlayerDirection(0, Direction.RIGHT);
        } else if (ke.getKeyCode() == KeyEvent.VK_W){
            gameBoard.changePlayerDirection(0, Direction.UP);
        } else if (ke.getKeyCode() == KeyEvent.VK_S){
            gameBoard.changePlayerDirection(0, Direction.DOWN);
        } else if (ke.getKeyCode() == KeyEvent.VK_LEFT){
            gameBoard.changePlayerDirection(1, Direction.LEFT);
        } else if (ke.getKeyCode() == KeyEvent.VK_RIGHT){
            gameBoard.changePlayerDirection(1, Direction.RIGHT);
        } else if (ke.getKeyCode() == KeyEvent.VK_UP){
            gameBoard.changePlayerDirection(1, Direction.UP);
        } else if (ke.getKeyCode() == KeyEvent.VK_DOWN){
            gameBoard.changePlayerDirection(1, Direction.DOWN);
        }
    }

    @Override
    public void keyReleased(KeyEvent ke) {
    }
}
